/**
 * A queue for 'Block' objects implemented as a singly linked list. The number of elements of the
 * queue is not limited. The queue may also contain entries of 'null'.
 */
//
// TODO: Complete the methods in 'BlockQueue'.
//       You can define further classes and methods for the implementation of
//       the singly linked list if needed.
//       Do NOT use the Java-Collection framework in 'Building' or any other class.
//
public class BlockQueue {

    //TODO: additional variables, constructors and methods must be private.
    private Block[] bQueue;
    private int head;
    private int tail;
    private int size;

    /**
     * Initializes 'this' as an empty list.
     */
    public BlockQueue() {
        this.bQueue = new Block [10];
        this.head = 0;
        this.tail = 0;
        this.size = 0;
    }

    /**
     * Initializes this queue as an independent copy of 'queue'. Later changes of 'this'
     * will not affect 'queue' and vice versa.
     *
     * @param queue the queue from which the elements are copied to 'this', queue != null.
     */
    public BlockQueue(BlockQueue queue) {
        this.bQueue = new Block [queue.bQueue.length];
        this.head = queue.head;
        this.tail = queue.tail;
        this.size = queue.size;

        for (int i = 0; i < queue.bQueue.length; i++){
            this.bQueue[i] = queue.bQueue[i];
        }
    }

    /**
     * Adds the specified element 'v' to this queue.
     *
     * @param v the variable that is added ('v' can also be 'null').
     */
    public void add(Block v) {
        //increase size if queue full
        if(this.tail == bQueue.length - 1){
            Block[] newArr = new Block [this.bQueue.length * 2];
            for (int i = 0; i < this.bQueue.length; i++){
                newArr[i] = this.bQueue[i];
            }
            this.bQueue = newArr;
        }
        this.bQueue[this.tail] = v;
        //adjust tail
        this.tail = (this.tail + 1) % this.bQueue.length;
        this.size++;
    }

    /**
     * Retrieves and removes an element from this queue. Returns 'null' if the list is empty.
     *
     * @return the next element in this queue, or 'null' if the queue is empty.
     */
    public Block poll() {
        if(this.size == 0){
            return null;
        }
        Block remove = this.bQueue[this.head];
        this.bQueue[this.head] = null;
        this.head = (this.head + 1) % this.bQueue.length;
        this.size--;

        if(this.size == 0){
            this.head = 0;
            this.tail = 0;
        }
        return remove;
    }

    /**
     * Returns the number of entries in this queue (including 'null' entries).
     *
     * @return the number of entries in this queue (including 'null' entries).
     */
    public int size() {
        return this.size;
    }

    /**
     * Returns a string representation of this queue. The string representation consists
     * of the queue's elements in the order they have been added to the queue,
     * enclosed in square brackets ("[]"). Adjacent elements are separated by ','.
     * Example: "[[2x5],[4x2],[2x3]]"
     *
     * @return a string representation of this queue.
     */
    public String toString() {
        String returnVal = "[" + this.bQueue[0].toString();
        for (int i = 1; i < this.bQueue.length; i++){
            if(this.bQueue[i] != null){
                returnVal = returnVal + "," + this.bQueue[i].toString();
            }
        }
        return returnVal + "]";
    }
}

// TODO: define further classes, if needed (either here or in a separate file).
